;============================================================================
; 				     
;============================================================================
		LIST p=16F873			;  
		RADIX HEX			;   
		INCLUDE "P16F873.INC"		;    
		__CONFIG b'11111101110101'
;    		= 11
;   		= 1
;  10 					= 1
;    			= 1
; CPD -     .		= 1
; LVP -   .	= 0
; BODEN -    U . .	= 1
;    		= 11
; PWRTE -    .	= 0
; WDTE -    		= 1
;  - , 4 				= 01
;============================================================================
;		
;============================================================================
MOVFF	MACRO   F1,F2      	;  F1- F2
		MOVFW	F1
		MOVWF	F2
	ENDM
MOVLF	MACRO   CONST,F1	;    
		MOVLW	CONST
		MOVWF	F1
	ENDM
;============================================================================
	ORG	0x00			;  
	CBLOCK	20H			;   
		T_INT			;   
		TEMP			;   
		HL1			; ,   
		HL2			;  
		POZ			;    0
		TIME_L			;     
		TIME_H			; 1 -   
		U1			; 
		U2			; 
		U3			; 
		U4			; 
		U5			; 
		S_KEY			;   
		T_W			;   
		T_STATUS		;   
		T_PCLATH		;     
		T_FSR			;    
	ENDC				;   
	GOTO	SETUP			;    
	ORG	0x04
;============================================================================
;	      0  1
;============================================================================
		BTFSC	PIR1,0		;     1	
		GOTO	int_handler1	;     1
;============================================================================
int_handler0	;   b  
		MOVWF	T_W      	;     W
		MOVFF	STATUS,T_STATUS ;     STATUS   W
		BSF	PORTC,0		;  
		BSF	PORTC,1		;  
		BTFSC	POZ,0		; ,   :
		GOTO	$+5		;   - 
		MOVFF	HL1,PORTB	;    -  ()
		BCF	PORTC,0		;    ,  
		GOTO	$+4		;    
		MOVFF	HL2,PORTB	;   
		BCF	PORTC,1		;   
		MOVFF	PORTC,S_KEY	;   
		MOVLW	0x0C		;   
		ANDWF	S_KEY,F		;    ,    
		INCF	POZ, 1		;   
		;----------------------------------------------------------------------------
INT_EXIT0	BCF	INTCON,T0IF	;    TMR0
		MOVFF	T_STATUS,STATUS ;    STATUS,    
		SWAPF	T_W,F		;      
		SWAPF	T_W,W       	;    W,    
		CLRWDT
		RETFIE			;   
;============================================================================
;       T1
;============================================================================
int_handler1	;     
		MOVWF	T_W      	;     W
		MOVFF	STATUS,T_STATUS	;     STATUS   W
		MOVFF	FSR,T_FSR	; 
		MOVFF	TIME_H,TMR1H	;      
		MOVFF	TIME_L,TMR1L	;  1 -     
		CLRF	T_INT		;   -  "0"  
;----------------------------------------------------------------------------		
EXIT_T1		MOVFF	T_FSR,FSR	;  FSR
		MOVFF	T_STATUS,STATUS ;    STATUS,    
		SWAPF	T_W,F		;      
		SWAPF	T_W,W       	;    W,    
		CLRWDT			;     -  :  .
		BCF	PIR1,0		;      1
		RETFIE			;    
;============================================================================
;   
;============================================================================	
SETUP		CLRF	PORTA		;  ,    
		CLRF	PORTB		;  ,    
		CLRF	PORTC		;  ,    C
		MOVLF	0x9F,FSR	;    ADCON1
		MOVLF	0X02,INDF	;     :,   
		MOVLF	0x41,ADCON0	; F/8  4 ,  ,  .
		MOVLF	0x85,FSR	;     TRISA
		MOVLF	0x2F,INDF	;     - ,  4 
		MOVLF	0X86,FSR	;   TRISB
		MOVLF	0X00,INDF	;    - 
		MOVLF	0xFF,PORTB	;   "1" -  
		MOVLF	0X87,FSR	;   TRISC
		MOVLF	0XFC,INDF	;   C - 0,1 - ,  - 
		MOVLF	0X81,FSR	;   OPTION
		MOVLF	0XCF,INDF	;  "1100111"  OPTION: PUL_UP=Off,   WDT = 1:128
		MOVLF	0X31,T1CON	; T1CON -  , ,  8:1,  
		MOVLF	0X8C,FSR	;    PIE1
		BSF	INDF,TMR1IE	;     1
		MOVLF	0x98,FSR	;   USART,   TXSTA
		BSF	INDF,2		;   BRGH
		INCF	FSR,F		;    SPBRG
		MOVLF	d'12',INDF	;   
		DECF	FSR,F		;   TXSTA
		BCF	INDF,4		;   SYNC
		BSF	INDF,5		;   TXEN -  
		BSF	RCSTA,SPEN	;   SPEN
		BSF	RCSTA,CREN	;  
		CLRF	T2CON		;   TMR2
		CLRF	CCP1CON		;   CCP
		CLRF	T_INT		;      
		MOVLF	0XA0,INTCON	; B'10100000'  INTCON:   ,  TM0
		CLRF	TIME_L		;  
		MOVLF	0x7F,TIME_H	;     
		MOVWF	TIME_H		;   
		MOVLF	0x0C,S_KEY	;    
		GOTO	Start		;  
;============================================================================
;		 
;============================================================================
DESH_ZN		MOVF	TEMP,W
		ADDWF	PCL,F
		DT	0XC0,0XF9,0XA4,0XB0,0X99,0X92,0X82,0XF8,0X80,0X90	; 0,1,2,3,4,5,6,7,8,9		
		DT	0X88,0X83,0XC6,0XA1,0X86,0X8E				; A,B,C,D,E,F
;============================================================================
;			   
;============================================================================	
Start		BTFSS	PIR1,RCIF	; ,    ?
		GOTO	$+0x0B		;   - 
		MOVFF	RCREG,TEMP	;  
		TSTF	TEMP		;   ?
		SKPNZ			;  0
		GOTO	Start		;  
		INCF	TEMP,W		;  1
		SKPNZ			;   255,   0
		GOTO	Stop		;  "" 
		MOVFF	TEMP,TIME_H	;    
		TSTF	S_KEY		;   ? ,   
		SKPNZ			;   	
		GOTO	Stop		;  "",   
		BTFSC	S_KEY,2		; ,     
		GOTO	$+6		;  ,   
		INCF	TIME_H,F	;  
		SKPNZ			;    
		DECF	TIME_H,F	;   1,  255  
		BTFSC	S_KEY,2		;    
		GOTO	$+4		;   - 
		BTFSS	S_KEY,3		;    
		GOTO	$+2		; 
		GOTO	$-4		;  
		BTFSC	S_KEY,3		;    
		GOTO	$+6		;  , 
		DECF	TIME_H,F	;  
		SKPNZ			;   0
		INCF	TIME_H,F	;   1  - 0  
		BTFSC	S_KEY,3		;    
		GOTO	$+4		;  - 
		BTFSS	S_KEY,2		;    
		GOTO	$+2		; 
		GOTO	$-4		;  
		TSTF	T_INT		;   0
		SKPNZ			;  
		GOTO	Preor		;   
		MOVFF	TIME_H,TEMP	;   
		MOVLW	0x0F		;   
		ANDWF	TEMP,W 		;  
		SUBLW	0x0F		;   16
		MOVWF	TEMP		;   
		CALL	DESH_ZN		;   
		MOVWF	HL2		;    
		MOVFF	TIME_H,TEMP	;    
		MOVLW	0xF0		; 
		ANDWF	TEMP,F		;  
		SWAPF	TEMP,W		; 
		SUBLW	0x0F		;   16
		MOVWF	TEMP		;   
		CALL	DESH_ZN		; 
		MOVWF	HL1		;   
		GOTO	Start		;   
Preor		MOVLW	0x10		; 
		XORWF	PORTA,F		; ,    
		BCF	INTCON,GIE	;      
		MOVLF	0X81,ADCON0	;  0,  
		CALL	PAUZ_ACP	;   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 
		BSF	INTCON,GIE	;  
		MOVFF	ADRESH,U1	;     
		
		BCF	INTCON,GIE	;      
		MOVLF	0X89,ADCON0	;  1,  
		CALL	PAUZ_ACP	;   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 
		BSF	INTCON,GIE	;  
		MOVFF	ADRESH,U2	;     
		
		BCF	INTCON,GIE	;      
		MOVLF	0X91,ADCON0	;  2,  
		CALL	PAUZ_ACP	;   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 
		BSF	INTCON,GIE	;  
		MOVFF	ADRESH,U3	;     
		
		BCF	INTCON,GIE	;      
		MOVLF	0X99,ADCON0	;  3,  
		CALL	PAUZ_ACP	;   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 
		BSF	INTCON,GIE	;  
		MOVFF	ADRESH,U4	;     
		
		BCF	INTCON,GIE	;      
		MOVLF	0XA1,ADCON0	;  4,  
		CALL	PAUZ_ACP	;   
		BSF	ADCON0,2	;   
		BTFSC	ADCON0,2	; ,  
		GOTO	$-1		;  , 
		BSF	INTCON,GIE	;  
		MOVFF	ADRESH,U5	;     
		
		INCF	T_INT,F		;  ,  ,    
;--------------    USART ----------------------------------------
		MOVLF	0x98,FSR	;  TXSTA
		MOVLW	0xFF		;   
		MOVWF	TXREG		;    
		BTFSS	INDF,1		; 
		GOTO	$-1		;   
		MOVWF	TXREG		;  ..
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVWF	TXREG		;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVFF	U1,TXREG	;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVFF	U2,TXREG	;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVFF	U3,TXREG	;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVFF	U4,TXREG	;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		MOVFF	U5,TXREG	;
		BTFSS	INDF,1		;
		GOTO	$-1		;
		GOTO	Start		;   
;--------------      ------------------------------
PAUZ_ACP	MOVLF	0x08,TEMP	;  
		DECFSZ	TEMP,F		;  
		GOTO	$-1		;     - 
		RETURN			; 
;-------------- Stop ------------------------------------------
Stop		TSTF	S_KEY		; 
		SKPNZ			; 
		GOTO	$-2		;  
Stop0		BTFSS	PIR1,RCIF	; ,    ?
		GOTO	$+0x0B		;   - 
		MOVFF	RCREG,TEMP	;  
		TSTF	TEMP		;   ?
		SKPNZ			;  0
		GOTO	Start		;  
		INCF	TEMP,W		;  1
		SKPNZ			;   255,   0
		GOTO	Stop0		;  "" -   
		MOVFF	TEMP,TIME_H	;    
		TSTF	S_KEY		; 
		SKPZ			;  ?
		GOTO	Stop0		;  
		TSTF	S_KEY		;  
		SKPZ			; ,  
		GOTO	Start		;   
		GOTO	$-3		; 
		RETURN	
	End